rem RG:

gcc -O3 -m64 -fomit-frame-pointer -S Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.S -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY
gcc -O3 -m64 -fomit-frame-pointer Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.exe -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY

if exist Nakamichi_Kintaro++_GCC_5.10_64bit_generic.S del Nakamichi_Kintaro++_GCC_5.10_64bit_generic.S
if exist Nakamichi_Kintaro++_GCC_5.10_64bit_generic.exe del Nakamichi_Kintaro++_GCC_5.10_64bit_generic.exe

ren Nakamichi_Kintaro++.S Nakamichi_Kintaro++_GCC_5.10_64bit_generic.S 
ren Nakamichi_Kintaro++.exe Nakamichi_Kintaro++_GCC_5.10_64bit_generic.exe

gcc -O3 -m64 -fomit-frame-pointer -march=haswell -S Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.S -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY
gcc -O3 -m64 -fomit-frame-pointer -march=haswell Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.exe -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY

if exist Nakamichi_Kintaro++_GCC_5.10_64bit_haswell.S del Nakamichi_Kintaro++_GCC_5.10_64bit_haswell.S
if exist Nakamichi_Kintaro++_GCC_5.10_64bit_haswell.exe del Nakamichi_Kintaro++_GCC_5.10_64bit_haswell.exe

ren Nakamichi_Kintaro++.S Nakamichi_Kintaro++_GCC_5.10_64bit_haswell.S 
ren Nakamichi_Kintaro++.exe Nakamichi_Kintaro++_GCC_5.10_64bit_haswell.exe

rem TW:

gcc -O3 -m64 -fomit-frame-pointer -S Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.S -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY -D_N_TW
gcc -O3 -m64 -fomit-frame-pointer Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.exe -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY -D_N_TW

if exist Nakamichi_Kintaro++TW_GCC_5.10_64bit_generic.S del Nakamichi_Kintaro++TW_GCC_5.10_64bit_generic.S
if exist Nakamichi_Kintaro++TW_GCC_5.10_64bit_generic.exe del Nakamichi_Kintaro++TW_GCC_5.10_64bit_generic.exe

ren Nakamichi_Kintaro++.S Nakamichi_Kintaro++TW_GCC_5.10_64bit_generic.S 
ren Nakamichi_Kintaro++.exe Nakamichi_Kintaro++TW_GCC_5.10_64bit_generic.exe

gcc -O3 -m64 -fomit-frame-pointer -march=haswell -S Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.S -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY -D_N_TW
gcc -O3 -m64 -fomit-frame-pointer -march=haswell Nakamichi_Kintaro++.c -o Nakamichi_Kintaro++.exe -D_N_XMM -D_N_prefetch_4096 -D_N_Branchfull -D_N_HIGH_PRIORITY -D_N_TW

if exist Nakamichi_Kintaro++TW_GCC_5.10_64bit_haswell.S del Nakamichi_Kintaro++TW_GCC_5.10_64bit_haswell.S
if exist Nakamichi_Kintaro++TW_GCC_5.10_64bit_haswell.exe del Nakamichi_Kintaro++TW_GCC_5.10_64bit_haswell.exe

ren Nakamichi_Kintaro++.S Nakamichi_Kintaro++TW_GCC_5.10_64bit_haswell.S 
ren Nakamichi_Kintaro++.exe Nakamichi_Kintaro++TW_GCC_5.10_64bit_haswell.exe


@echo off
rem 
rem   -floop-parallelize-all      Mark all loops as parallel
rem   -fif-conversion             Perform conversion of conditional jumps to
rem                               branchless equivalents
rem   -fif-conversion2            Perform conversion of conditional jumps to
rem                               conditional execution
rem   -ftree-loop-if-convert      Convert conditional jumps in innermost loops to
rem                               branchless equivalents
rem   -m64                        Generate 64bit x86-64 code
rem -march=core2
rem -march=haswell
